package devguide.advanced.postingorder;
import oracle.jbo.AttributeList;
import oracle.jbo.Key;
import oracle.jbo.RowIterator;
import oracle.jbo.RowSet;
import oracle.jbo.domain.DBSequence;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.server.EntityDefImpl;
import oracle.jbo.server.EntityImpl;
import oracle.jbo.server.TransactionEvent;
import oracle.jbo.domain.Number;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
public class ProductImpl extends EntityImpl {
  public static final int PRODID = 0;
  public static final int NAME = 1;
  public static final int IMAGE = 2;
  public static final int DESCRIPTION = 3;
  public static final int SERVICEREQUEST = 4;
  private static EntityDefImpl mDefinitionObject;

  /**This is the default constructor (do not remove)
   */
  public ProductImpl() {
  }

  /**Retrieves the definition object for this instance class.
   */
  public static synchronized EntityDefImpl getDefinitionObject() {
    if (mDefinitionObject == null) {
      mDefinitionObject = (EntityDefImpl)EntityDefImpl.findDefObject("devguide.advanced.postingorder.Product");
    }
    return mDefinitionObject;
  }

  /**Gets the attribute value for ProdId, using the alias name ProdId
   */
  public DBSequence getProdId() {
    return (DBSequence)getAttributeInternal(PRODID);
  }

  /**Sets <code>value</code> as the attribute value for ProdId
   */
  public void setProdId(DBSequence value) {
    setAttributeInternal(PRODID, value);
  }

  /**Gets the attribute value for Name, using the alias name Name
   */
  public String getName() {
    return (String)getAttributeInternal(NAME);
  }

  /**Sets <code>value</code> as the attribute value for Name
   */
  public void setName(String value) {
    setAttributeInternal(NAME, value);
  }

  /**Gets the attribute value for Image, using the alias name Image
   */
  public String getImage() {
    return (String)getAttributeInternal(IMAGE);
  }

  /**Sets <code>value</code> as the attribute value for Image
   */
  public void setImage(String value) {
    setAttributeInternal(IMAGE, value);
  }

  /**Gets the attribute value for Description, using the alias name Description
   */
  public String getDescription() {
    return (String)getAttributeInternal(DESCRIPTION);
  }

  /**Sets <code>value</code> as the attribute value for Description
   */
  public void setDescription(String value) {
    setAttributeInternal(DESCRIPTION, value);
  }

  /**getAttrInvokeAccessor: generated method. Do not modify.
   */
  protected Object getAttrInvokeAccessor(int index, 
                                         AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case PRODID:
      return getProdId();
    case NAME:
      return getName();
    case IMAGE:
      return getImage();
    case DESCRIPTION:
      return getDescription();
    case SERVICEREQUEST:
      return getServiceRequest();
    default:
      return super.getAttrInvokeAccessor(index, attrDef);
    }
  }

  /**setAttrInvokeAccessor: generated method. Do not modify.
   */
  protected void setAttrInvokeAccessor(int index, Object value, 
                                       AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case PRODID:
      setProdId((DBSequence)value);
      return;
    case NAME:
      setName((String)value);
      return;
    case IMAGE:
      setImage((String)value);
      return;
    case DESCRIPTION:
      setDescription((String)value);
      return;
    default:
      super.setAttrInvokeAccessor(index, value, attrDef);
      return;
    }
  }

  /**Gets the associated entity oracle.jbo.RowIterator
   */
  public RowIterator getServiceRequest() {
    return (RowIterator)getAttributeInternal(SERVICEREQUEST);
  }

  /**Creates a Key object based on given key constituents
   */
  public static Key createPrimaryKey(DBSequence prodId) {
    return new Key(new Object[]{prodId});
  }
  /*
   * This member field is used to hang onto a reference to
   * the rowset of one or more new ServiceRequest that might
   * be references a new product.
   */
  RowSet newServiceRequestsBeforePost = null;
  public void postChanges(TransactionEvent TransactionEvent) {
    /* Only bother to update references if Product is a NEW one */
    if (getPostState() == STATUS_NEW) {
      /* 
       * Get a rowset of service requests related
       * to this new product before calling super
       */
      newServiceRequestsBeforePost = (RowSet)getServiceRequest();
    }
    super.postChanges(TransactionEvent);
  }
  /**
   * Overridding this method in this class allows
   * friendly access to the create() method by other
   * classes in this same package, like the ServiceRequestsAndProduct
   * view object implementation class, whose overridden create()
   * method needs to call this.
   * @param nameValuePair
   */
  protected void create(AttributeList nameValuePair) {
    super.create(nameValuePair);
  }
  protected void refreshFKInNewContainees() {
    if (newServiceRequestsBeforePost != null) {
      Number newProdId = getProdId().getSequenceNumber();
      /* 
       * Process the rowset of service requests that referenced
       * the new product prior to posting, and update their
       * ProdId attribute to reflect the refreshed ProdId value
       * that was assigned by a database sequence during posting.
       */
      while (newServiceRequestsBeforePost.hasNext()) {
        ServiceRequestImpl svrReq =
          (ServiceRequestImpl)newServiceRequestsBeforePost.next();
        svrReq.setProdId(newProdId);
      }
      closeNewServiceRequestRowSet();
    }  
  }
  private void closeNewServiceRequestRowSet() {
    if (newServiceRequestsBeforePost != null) {
      newServiceRequestsBeforePost.closeRowSet();
      newServiceRequestsBeforePost = null;
    }
  }
  protected void handlePostChangesError() {
    super.handlePostChangesError();
    closeNewServiceRequestRowSet();
  }
}
