package devguide.advanced.postingorder;
import oracle.jbo.AttributeList;
import oracle.jbo.JboException;
import oracle.jbo.RowCreateException;
import oracle.jbo.domain.DBSequence;
import oracle.jbo.domain.Number;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.server.ViewRowImpl;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
public class ServiceRequestAndProductRowImpl extends ViewRowImpl {
  public static final int NAME = 0;
  public static final int DESCRIPTION = 1;
  public static final int PROBLEMDESCRIPTION = 2;
  public static final int CREATEDBY = 3;
  public static final int EMAIL = 4;
  public static final int SVRID = 5;
  public static final int PRODID = 6;
  public static final int USERID = 7;

  /**This is the default constructor (do not remove)
   */
  public ServiceRequestAndProductRowImpl() {
  }
  /**
   * By default, the framework will automatically create the new
   * underlying entity object instances that are related to this
   * view object row being created.
   *
   * We override this default view object row creation to explicitly
   * pre-populate the new (detail) ServiceRequestImpl instance using
   * the new (master) ProductImpl instance. Since all entity objects
   * implement the AttributeList interface, we can directly pass the
   * new ProductImpl instance to the ServiceRequestImpl create()
   * method that accepts an AttributeList.
   */
  protected void create(AttributeList attributeList) {
    // The view row will already have created "blank" entity instances
    ProductImpl newProduct = getProduct();
    ServiceRequestImpl newServiceRequest = getServiceRequest();
     try {
        // Let product "blank" entity instance to do programmatic defaulting
        newProduct.create(attributeList);
        // Let service request "blank" entity instance to do programmatic
        // defaulting passing in new ProductImpl instance so its attributes
        // are available to the ServiceRequestImpl's create method.
        newServiceRequest.create(newProduct);
     }
     catch (JboException ex) {
       newProduct.revert();
       newServiceRequest.revert();      
       throw ex;
     }
     catch (Exception otherEx) {
       newProduct.revert();
       newServiceRequest.revert();      
       throw new RowCreateException(true      /* EO Row? */,
                                    "Product" /* EO Name */,
                                    otherEx   /* Details */);
     }
  }
  /**Gets ServiceRequest entity object.
   */
  public ServiceRequestImpl getServiceRequest() {
    return (ServiceRequestImpl)getEntity(0);
  }

  /**Gets Product entity object.
   */
  public ProductImpl getProduct() {
    return (ProductImpl)getEntity(1);
  }

  /**Gets the attribute value for PROBLEM_DESCRIPTION using the alias name ProblemDescription
   */
  public String getProblemDescription() {
    return (String) getAttributeInternal(PROBLEMDESCRIPTION);
  }

  /**Sets <code>value</code> as attribute value for PROBLEM_DESCRIPTION using the alias name ProblemDescription
   */
  public void setProblemDescription(String value) {
    setAttributeInternal(PROBLEMDESCRIPTION, value);
  }

  /**Gets the attribute value for SVR_ID using the alias name SvrId
   */
  public DBSequence getSvrId() {
    return (DBSequence)getAttributeInternal(SVRID);
  }

  /**Sets <code>value</code> as attribute value for SVR_ID using the alias name SvrId
   */
  public void setSvrId(DBSequence value) {
    setAttributeInternal(SVRID, value);
  }

  /**Gets the attribute value for CREATED_BY using the alias name CreatedBy
   */
  public Number getCreatedBy() {
    return (Number) getAttributeInternal(CREATEDBY);
  }

  /**Sets <code>value</code> as attribute value for CREATED_BY using the alias name CreatedBy
   */
  public void setCreatedBy(Number value) {
    setAttributeInternal(CREATEDBY, value);
  }

  /**Gets the attribute value for NAME using the alias name Name
   */
  public String getName() {
    return (String) getAttributeInternal(NAME);
  }

  /**Sets <code>value</code> as attribute value for NAME using the alias name Name
   */
  public void setName(String value) {
    setAttributeInternal(NAME, value);
  }

  /**Gets the attribute value for PROD_ID using the alias name ProdId
   */
  public DBSequence getProdId() {
    return (DBSequence)getAttributeInternal(PRODID);
  }

  /**Sets <code>value</code> as attribute value for PROD_ID using the alias name ProdId
   */
  public void setProdId(DBSequence value) {
    setAttributeInternal(PRODID, value);
  }

  /**Gets the attribute value for DESCRIPTION using the alias name Description
   */
  public String getDescription() {
    return (String) getAttributeInternal(DESCRIPTION);
  }

  /**Sets <code>value</code> as attribute value for DESCRIPTION using the alias name Description
   */
  public void setDescription(String value) {
    setAttributeInternal(DESCRIPTION, value);
  }

  /**getAttrInvokeAccessor: generated method. Do not modify.
   */
  protected Object getAttrInvokeAccessor(int index, 
                                         AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case NAME:
      return getName();
    case DESCRIPTION:
      return getDescription();
    case PROBLEMDESCRIPTION:
      return getProblemDescription();
    case CREATEDBY:
      return getCreatedBy();
    case EMAIL:
      return getEmail();
    case SVRID:
      return getSvrId();
    case PRODID:
      return getProdId();
    case USERID:
      return getUserId();
    default:
      return super.getAttrInvokeAccessor(index, attrDef);
    }
  }

  /**setAttrInvokeAccessor: generated method. Do not modify.
   */
  protected void setAttrInvokeAccessor(int index, Object value, 
                                       AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case NAME:
      setName((String)value);
      return;
    case DESCRIPTION:
      setDescription((String)value);
      return;
    case PROBLEMDESCRIPTION:
      setProblemDescription((String)value);
      return;
    case CREATEDBY:
      setCreatedBy((Number)value);
      return;
    case EMAIL:
      setEmail((String)value);
      return;
    default:
      super.setAttrInvokeAccessor(index, value, attrDef);
      return;
    }
  }

  /**Gets User1 entity object.
   */
  public UserImpl getUser1() {
    return (UserImpl)getEntity(2);
  }

  /**Gets the attribute value for EMAIL using the alias name Email
   */
  public String getEmail() {
    return (String) getAttributeInternal(EMAIL);
  }

  /**Sets <code>value</code> as attribute value for EMAIL using the alias name Email
   */
  public void setEmail(String value) {
    setAttributeInternal(EMAIL, value);
  }

  /**Gets the attribute value for USER_ID using the alias name UserId
   */
  public Number getUserId() {
    return (Number) getAttributeInternal(USERID);
  }
}
