package devguide.advanced.postingorder;
import oracle.jbo.AttributeList;
import oracle.jbo.Key;
import oracle.jbo.RowIterator;
import oracle.jbo.domain.DBSequence;
import oracle.jbo.domain.Date;
import oracle.jbo.domain.Number;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.server.EntityDefImpl;
import oracle.jbo.server.EntityImpl;
import oracle.jbo.server.TransactionEvent;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
public class ServiceRequestImpl extends EntityImpl {
  public static final int SVRID = 0;
  public static final int STATUS = 1;
  public static final int REQUESTDATE = 2;
  public static final int PROBLEMDESCRIPTION = 3;
  public static final int PRODID = 4;
  public static final int CREATEDBY = 5;
  public static final int ASSIGNEDTO = 6;
  public static final int ASSIGNEDDATE = 7;
  public static final int PRODUCT = 8;
  public static final int USER = 9;
  public static final int USER1 = 10;
  public static final int SERVICEHISTORY = 11;
  private static EntityDefImpl mDefinitionObject;

  /**This is the default constructor (do not remove)
   */
  public ServiceRequestImpl() {
  }

  /**Retrieves the definition object for this instance class.
   */
  public static synchronized EntityDefImpl getDefinitionObject() {
    if (mDefinitionObject == null) {
      mDefinitionObject = (EntityDefImpl)EntityDefImpl.findDefObject("devguide.advanced.postingorder.ServiceRequest");
    }
    return mDefinitionObject;
  }
  public void postChanges(TransactionEvent e) {
    if (getPostState() == STATUS_NEW ||
        getPostState() == STATUS_MODIFIED) {
      ProductImpl product = getProduct();
      /* If there is an associated product */
      if (product != null) {
        /* And if it's post-status is NEW */
        if (product.getPostState() == STATUS_NEW) {
          /* Post it first, before posting this entity by calling super below */
          product.postChanges(e);
        }
      }
    }
    super.postChanges(e);
  }

  /**Gets the attribute value for SvrId, using the alias name SvrId
   */
  public DBSequence getSvrId() {
    return (DBSequence)getAttributeInternal(SVRID);
  }

  /**Sets <code>value</code> as the attribute value for SvrId
   */
  public void setSvrId(DBSequence value) {
    setAttributeInternal(SVRID, value);
  }

  /**Gets the attribute value for Status, using the alias name Status
   */
  public String getStatus() {
    return (String)getAttributeInternal(STATUS);
  }

  /**Sets <code>value</code> as the attribute value for Status
   */
  public void setStatus(String value) {
    setAttributeInternal(STATUS, value);
  }

  /**Gets the attribute value for RequestDate, using the alias name RequestDate
   */
  public Date getRequestDate() {
    return (Date)getAttributeInternal(REQUESTDATE);
  }

  /**Sets <code>value</code> as the attribute value for RequestDate
   */
  public void setRequestDate(Date value) {
    setAttributeInternal(REQUESTDATE, value);
  }

  /**Gets the attribute value for ProblemDescription, using the alias name ProblemDescription
   */
  public String getProblemDescription() {
    return (String)getAttributeInternal(PROBLEMDESCRIPTION);
  }

  /**Sets <code>value</code> as the attribute value for ProblemDescription
   */
  public void setProblemDescription(String value) {
    setAttributeInternal(PROBLEMDESCRIPTION, value);
  }

  /**Gets the attribute value for ProdId, using the alias name ProdId
   */
  public Number getProdId() {
    return (Number)getAttributeInternal(PRODID);
  }

  /**Sets <code>value</code> as the attribute value for ProdId
   */
  public void setProdId(Number value) {
    setAttributeInternal(PRODID, value);
  }

  /**Gets the attribute value for CreatedBy, using the alias name CreatedBy
   */
  public Number getCreatedBy() {
    return (Number)getAttributeInternal(CREATEDBY);
  }

  /**Sets <code>value</code> as the attribute value for CreatedBy
   */
  public void setCreatedBy(Number value) {
    setAttributeInternal(CREATEDBY, value);
  }

  /**Gets the attribute value for AssignedTo, using the alias name AssignedTo
   */
  public Number getAssignedTo() {
    return (Number)getAttributeInternal(ASSIGNEDTO);
  }

  /**Sets <code>value</code> as the attribute value for AssignedTo
   */
  public void setAssignedTo(Number value) {
    setAttributeInternal(ASSIGNEDTO, value);
  }

  /**Gets the attribute value for AssignedDate, using the alias name AssignedDate
   */
  public Date getAssignedDate() {
    return (Date)getAttributeInternal(ASSIGNEDDATE);
  }

  /**Sets <code>value</code> as the attribute value for AssignedDate
   */
  public void setAssignedDate(Date value) {
    setAttributeInternal(ASSIGNEDDATE, value);
  }

  /**getAttrInvokeAccessor: generated method. Do not modify.
   */
  protected Object getAttrInvokeAccessor(int index, 
                                         AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case SVRID:
      return getSvrId();
    case STATUS:
      return getStatus();
    case REQUESTDATE:
      return getRequestDate();
    case PROBLEMDESCRIPTION:
      return getProblemDescription();
    case PRODID:
      return getProdId();
    case CREATEDBY:
      return getCreatedBy();
    case ASSIGNEDTO:
      return getAssignedTo();
    case ASSIGNEDDATE:
      return getAssignedDate();
    case SERVICEHISTORY:
      return getServiceHistory();
    case PRODUCT:
      return getProduct();
    case USER:
      return getUser();
    case USER1:
      return getUser1();
    default:
      return super.getAttrInvokeAccessor(index, attrDef);
    }
  }

  /**setAttrInvokeAccessor: generated method. Do not modify.
   */
  protected void setAttrInvokeAccessor(int index, Object value, 
                                       AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case SVRID:
      setSvrId((DBSequence)value);
      return;
    case STATUS:
      setStatus((String)value);
      return;
    case PROBLEMDESCRIPTION:
      setProblemDescription((String)value);
      return;
    case PRODID:
      setProdId((Number)value);
      return;
    case CREATEDBY:
      setCreatedBy((Number)value);
      return;
    case ASSIGNEDTO:
      setAssignedTo((Number)value);
      return;
    case ASSIGNEDDATE:
      setAssignedDate((Date)value);
      return;
    default:
      super.setAttrInvokeAccessor(index, value, attrDef);
      return;
    }
  }

  /**Gets the associated entity ProductImpl
   */
  public ProductImpl getProduct() {
    return (ProductImpl)getAttributeInternal(PRODUCT);
  }

  /**Sets <code>value</code> as the associated entity ProductImpl
   */
  public void setProduct(ProductImpl value) {
    setAttributeInternal(PRODUCT, value);
  }

  /**Gets the associated entity oracle.jbo.server.EntityImpl
   */
  public UserImpl getUser() {
    return (UserImpl)getAttributeInternal(USER);
  }

  /**Sets <code>value</code> as the associated entity oracle.jbo.server.EntityImpl
   */
  public void setUser(UserImpl value) {
    setAttributeInternal(USER, value);
  }

  /**Gets the associated entity oracle.jbo.server.EntityImpl
   */
  public UserImpl getUser1() {
    return (UserImpl)getAttributeInternal(USER1);
  }

  /**Sets <code>value</code> as the associated entity oracle.jbo.server.EntityImpl
   */
  public void setUser1(UserImpl value) {
    setAttributeInternal(USER1, value);
  }

  /**Gets the associated entity oracle.jbo.RowIterator
   */
  public RowIterator getServiceHistory() {
    return (RowIterator)getAttributeInternal(SERVICEHISTORY);
  }

  /**Creates a Key object based on given key constituents
   */
  public static Key createPrimaryKey(DBSequence svrId) {
    return new Key(new Object[]{svrId});
  }
//  protected void refreshFKInNewContainees() {
//    super.refreshFKInNewContainees();
//  }
  /**
   * Overridden to pre-populate the product id if it is passed in the
   * attribute list by the caller, as it will be when the 
   * overridden create() method in the ServiceRequestAndProductImpl
   * class invokes this.
   * @param nameValuePair
   */
  protected void create(AttributeList nameValuePair) {
    super.create(nameValuePair);
    if (nameValuePair != null) {
      DBSequence prodid = (DBSequence)nameValuePair.getAttribute("ProdId");
      if (prodid != null) {
        setProdId(prodid.getSequenceNumber());
      }    
    }
  }
}
