create or replace package body products_api is
  procedure insert_product(p_prod_id number,
                           p_name varchar2,
                           p_image varchar2,
                           p_description varchar2) is
  begin
    insert into products(prod_id, name, image, description)
           values(p_prod_id,p_name,p_image,p_description);
  end insert_product;
  procedure update_product(p_prod_id number,
                           p_name varchar2,
                           p_image varchar2,
                           p_description varchar2) is
  begin
    update products
       set name = p_name,
           image = p_image,
           description = p_description
    where prod_id = p_prod_id;
  end update_product;
  procedure delete_product(p_prod_id number) is
  begin
    delete from products where prod_id = p_prod_id;
  end;
  procedure lock_product(p_prod_id number,
                         p_name OUT varchar2,
                         p_image OUT varchar2,
                         p_description OUT varchar2) is
  begin
    select name,image,description
      into p_name, p_image, p_description
      from products
     where prod_id = p_prod_id
     for update nowait;
  end lock_product;
  procedure select_product(p_prod_id number,
                           p_name OUT varchar2,
                           p_image OUT varchar2,
                           p_description OUT varchar2) is
  begin
    select name,image,description
      into p_name, p_image, p_description
      from products
     where prod_id = p_prod_id;
  end select_product;  
end products_api;
.
/
show errors