package devguide.advanced.plsqlwrap;
import devguide.advanced.plsqlwrap.fwkext.PLSQLEntityImpl;

import java.sql.CallableStatement;
import java.sql.SQLException;

import oracle.jbo.AlreadyLockedException;
import oracle.jbo.JboException;
import oracle.jbo.Key;
import oracle.jbo.domain.Number;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.server.EntityDefImpl;
import oracle.jbo.server.TransactionEvent;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
public class ProductImpl extends PLSQLEntityImpl {
  public static final int PRODID = 0;
  public static final int NAME = 1;
  public static final int IMAGE = 2;
  public static final int DESCRIPTION = 3;
  private static EntityDefImpl mDefinitionObject;

  /**This is the default constructor (do not remove)
   */
  public ProductImpl() {
  }

  /**Retrieves the definition object for this instance class.
   */
  public static synchronized EntityDefImpl getDefinitionObject() {
    if (mDefinitionObject == null) {
      mDefinitionObject = 
          (EntityDefImpl)EntityDefImpl.findDefObject("devguide.advanced.plsqlwrap.Product");
    }
    return mDefinitionObject;
  }
  protected void callInsertProcedure(TransactionEvent e) {
    callStoredProcedure("products_api.insert_product(?,?,?,?)", 
                        new Object[] { getProdId(), getName(), getImage(), 
                                       getDescription() });
  }
  protected void callUpdateProcedure(TransactionEvent e) {
    callStoredProcedure("products_api.update_product(?,?,?,?)", 
                        new Object[] { getProdId(), getName(), getImage(), 
                                       getDescription() });
  }
  protected void callDeleteProcedure(TransactionEvent e) {
    callStoredProcedure("products_api.delete_product(?)",
                        new Object[] { getProdId() });
  }
  protected void callLockProcedureAndCheckForRowInconsistency() {
    String stmt = "begin products_api.lock_product(?,?,?,?);end;";
    CallableStatement st = getDBTransaction().createCallableStatement(stmt, 0);
    try {
      st.registerOutParameter(2, VARCHAR2);
      st.registerOutParameter(3, VARCHAR2);
      st.registerOutParameter(4, VARCHAR2);
      st.setObject(1,getProdId());
      st.executeUpdate();
      String possiblyUpdatedName = st.getString(2);
      String possiblyUpdatedImage = st.getString(3);
      String possiblyUpdatedDesc  = st.getString(4);
      compareOldAttrTo(NAME,possiblyUpdatedName);
      compareOldAttrTo(IMAGE,possiblyUpdatedImage);
      compareOldAttrTo(DESCRIPTION,possiblyUpdatedDesc);
    } catch (SQLException e) {
      if (Math.abs(e.getErrorCode()) == 54) {
        throw new AlreadyLockedException(e);
      } else {
        throw new JboException(e);
      }
    } finally {
      if (st != null) {
        try {
          st.close();
        } catch (SQLException e) {
        }
      }
    }
  }
  protected void callSelectProcedure() {
    String stmt = "begin products_api.select_product(?,?,?,?);end;";
    CallableStatement st = getDBTransaction().createCallableStatement(stmt, 0);
    try {
      st.registerOutParameter(2, VARCHAR2);
      st.registerOutParameter(3, VARCHAR2);
      st.registerOutParameter(4, VARCHAR2);
      st.setObject(1,getProdId());
      st.executeUpdate();
      String possiblyUpdatedName = st.getString(2);
      String possiblyUpdatedImage = st.getString(3);
      String possiblyUpdatedDesc  = st.getString(4);
      populateAttribute(NAME,possiblyUpdatedName,true,false,false);
      populateAttribute(IMAGE,possiblyUpdatedImage,true,false,false);
      populateAttribute(DESCRIPTION,possiblyUpdatedDesc,true,false,false);
    } catch (SQLException e) {
        throw new JboException(e);
    } finally {
      if (st != null) {
        try {
          st.close();
        } catch (SQLException e) {
        }
      }
    }
  }

  /**Gets the attribute value for ProdId, using the alias name ProdId
   */
  public Number getProdId() {
    return (Number)getAttributeInternal(PRODID);
  }

  /**Sets <code>value</code> as the attribute value for ProdId
   */
  public void setProdId(Number value) {
    setAttributeInternal(PRODID, value);
  }

  /**Gets the attribute value for Name, using the alias name Name
   */
  public String getName() {
    return (String)getAttributeInternal(NAME);
  }

  /**Sets <code>value</code> as the attribute value for Name
   */
  public void setName(String value) {
    setAttributeInternal(NAME, value);
  }

  /**Gets the attribute value for Image, using the alias name Image
   */
  public String getImage() {
    return (String)getAttributeInternal(IMAGE);
  }

  /**Sets <code>value</code> as the attribute value for Image
   */
  public void setImage(String value) {
    setAttributeInternal(IMAGE, value);
  }

  /**Gets the attribute value for Description, using the alias name Description
   */
  public String getDescription() {
    return (String)getAttributeInternal(DESCRIPTION);
  }

  /**Sets <code>value</code> as the attribute value for Description
   */
  public void setDescription(String value) {
    setAttributeInternal(DESCRIPTION, value);
  }

  /**getAttrInvokeAccessor: generated method. Do not modify.
   */
  protected Object getAttrInvokeAccessor(int index, 
                                         AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case PRODID:
      return getProdId();
    case NAME:
      return getName();
    case IMAGE:
      return getImage();
    case DESCRIPTION:
      return getDescription();
    default:
      return super.getAttrInvokeAccessor(index, attrDef);
    }
  }

  /**setAttrInvokeAccessor: generated method. Do not modify.
   */
  protected void setAttrInvokeAccessor(int index, Object value, 
                                       AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case PRODID:
      setProdId((Number)value);
      return;
    case NAME:
      setName((String)value);
      return;
    case IMAGE:
      setImage((String)value);
      return;
    case DESCRIPTION:
      setDescription((String)value);
      return;
    default:
      super.setAttrInvokeAccessor(index, value, attrDef);
      return;
    }
  }

  /**Creates a Key object based on given key constituents
   */
  public static Key createPrimaryKey(Number prodId) {
    return new Key(new Object[] { prodId });
  }
}
