package devguide.advanced.inheritance.client;
import devguide.advanced.inheritance.queries.common.ManagerListRow;
import devguide.advanced.inheritance.queries.common.TechnicianListRow;
import devguide.advanced.inheritance.queries.common.UserListRow;

import oracle.jbo.ApplicationModule;
import oracle.jbo.ViewObject;
import oracle.jbo.client.Configuration;
public class TestViewRowPolymorphism {
  public static void main(String[] args) {
    String amDef = "devguide.advanced.inheritance.UserModule";
    String config = "UserModuleLocal";
    ApplicationModule am = Configuration.createRootApplicationModule(amDef, config);
    ViewObject vo = am.findViewObject("UserList");
    vo.executeQuery();
    while (vo.hasNext()) {
      UserListRow user = (UserListRow)vo.next();
      System.out.print(user.getEmail()+"->");
      if (user instanceof ManagerListRow) {
        ManagerListRow mgr = (ManagerListRow)user;
        mgr.performManagerFeature();       
        System.out.println("Next Review:"+mgr.getNextReview());
      }
      else if (user instanceof TechnicianListRow) {
        TechnicianListRow tech = (TechnicianListRow)user;
        tech.performTechnicianFeature();       
        System.out.println("Certified:"+tech.getCertified());        
      }
      else {
        user.performUserFeature();
      }
    }
    Configuration.releaseRootApplicationModule(am, true);
  }
}
